#include <avr/io.h>
#include <stdio.h>
#include <stdint.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "spi.h"
#include "ST7735R_TFT.h"
#include "game.h"
#include "spi.c"
#include "game.c"
#define Xchannel	7

void ADC_init(void)
{
    ADMUX = (1 << REFS0);
    ADCSRA = (1 << ADEN) | (5 << ADPS0);
}

void speaker_morse(int tip)
{
    int delay = 1;
    int i;
    DDRD |= (1 << PD6);     // PD4 trebuie sa fie output

    for (i = 0; i < tip * 50 / delay; i++)
    {
        PIND = (1 << PD6);  // alternam starea iesirii
        _delay_ms(1);
    }
}

void IO_init(void)
{
	/* Setare Buzzer */

	DDRD &= ~(1 << PD6);

	/* Activez rezistenta de pull-up */
	PORTD |= (1 << PD6);

	/* Setez pinul PD0 ca iesire buzzer */
	DDRD |= (1 << PD6);

	/* Opresc buzzer-ul. */
	PORTD &= ~(1 << PD6);
}




/*
 * Functia porneste o noua conversie pentru canalul precizat.
 * In modul fara intreruperi, apelul functiei este blocant. Aceasta se
 * intoarce cand conversia este finalizata.
 *
 * In modul cu intreruperi apelul NU este blocant.
 *
 * @return Valoarea numerica raw citita de ADC de pe canlul specificat.
 */
uint16_t ADC_get(uint8_t channel)
{
    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

    ADCSRA |= (1 << ADSC);
    while(ADCSRA & (1 << ADSC));

    return ADC;
}

int main(void)
{

	int xval;
	int yval;
	int stop;

	if (abs(xval) > 0)
	{
			while(1)
				speaker_morse(100);
	}


    // Init ADC.
    ADC_init();
	
	IO_init();
	
	// Init SPI
    SPI_init();
    ST7735R_Begin();
    // Init LCD
    ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 255, 255, 255);
    
	
    init();
    if(stop > 0)
    {

    }
    for(;;)
    {
			xval = ADC_get(7) - 512;
			yval = ADC_get(6) - 512;
            move_snake(xval / 64, yval / 64);

            int buzz = 0;
            loop();

			

			if (buzz == 0)
				_delay_ms(160);
			else if (buzz == 1)
				_delay_ms(50);
			else if (buzz == 1)
				_delay_ms(50);
			else if (buzz == 0)
				_delay_ms(80);

    }
  


    return 0;
}

